using NodePipeline.Abstractions.Attributes;
using NodePipeline.Abstractions.Interfaces.Nodes;
using NodePipeline.Abstractions.Models;
using NodePipeline.Engine.CodeGeneration.Abstractions.Models;

namespace NodePipeline.Engine.Tests.CodeGeneratorTests.Fixtures.MockNodes;

public class OneParameterNode : INode
{
    [NodeField(FieldDirection.Parameter)] public NodeField<int> Parameter { get; set; } = null!;

    public void Execute()
    {
        throw new NotImplementedException();
    }

    internal static NodeDescriptor GetDescriptor()
    {
        return new NodeDescriptor(nameof(OneParameterNode), false, typeof(OneParameterNode).FullName!,
            typeof(OneParameterNode).FullName!,
            [
                new NodeFieldDescriptor(nameof(Parameter), nameof(Parameter), typeof(int).FullName!, false, false,
                    false,
                    FieldDirection.Parameter, null)
            ], true, null);
    }
}